// delay before the menu collapses
var delay = 500;

// holds the window timeout
var timeout = null;
// holds the node, that should be collapsed
var globalNode = null;
// has the user a IE
var isIE = navigator.userAgent.toLowerCase().indexOf('msie') != -1;

/**
 * Calls the method to register the menu event handlers.
 * That is needed to ensure that the menu will collapse.
 * @author	Jammni
 * @date		2008-04-20
 */
function insertScript()
{
	// do that only if the navigation item is available
	if (document.getElementById("navigation"))
	{
		insertScriptByNode(document.getElementById("navigation").firstChild);
		
		// set position of sub menus
		setPositions();
	}
}

/**
 * Inserts the event handler methods for OnMouseOver, OnMouseOut, OnFocus and OnBlur.
 * @author	Jammni
 * @date		2008-04-20
 * @param		first child node of an UL tag which contains the menu or a part of the menu
 */
function insertScriptByNode(node)
{
	//  for each sub item
	do
	{
		// is there an UL tag as a children? if that is the case, we have to register the event handlers
		if (isUL(node.firstChild))
		{
			// event handlers
			node.onmouseover = showSubMenu;
			node.onmouseout = hideSubMenu;
			node.onfocus = showSubMenu;
			node.onblur = hideSubMenu;

			// recursively check the children
			insertScriptByNode(isUL(node.firstChild).firstChild);
		}
		// nect node
		node = node.nextSibling;
	} while(node);
}

/**
 * Get the next UL node if it is available.
 * @author	Jammni
 * @date		2008-04-20
 * @param		child of a LI tag
 * @return	UL children node if one is available
 *			otherwise false
 */
function isUL(node)
{
	do
	{
		if (node)
			node = node.nextSibling;
		if ((node) && (node.nodeName == "UL"))
			return node;
	} while (node);
	return false;
}

function setPositions()
{
	node = document.getElementById("navigation");
	if (!node)
		return;

	node = node.firstChild;

	while (node)
	{
		if (isUL(node.firstChild))
		{
			subNode = node.firstChild;
			while ((subNode) && (subNode.nodeName != "UL"))
				subNode = subNode.nextSibling;
			if (subNode)
			{
				if (isIE)
					subNode.style.position = "absolute";
				else
					subNode.style.position = "fixed";
				subNode.style.left = (getOffsetLeft(subNode) + subNode.parentNode.offsetWidth + (isIE ? 3 : 2)) + "px";
				subNode.style.top = (getOffsetTop(subNode) - (isIE ? 2 : 3)) + "px";
			}
		}
		
		node = node.nextSibling;
	}
}

function getOffsetLeft(node)
{
	var nRes = 0;
	while ((node) && (node.parentNode) && (node.parentNode.offsetLeft))
	{
		nRes += node.parentNode.offsetLeft;
		if (node.parentNode.style.borderLeftWidth)
			nRes += (node.parentNode.style.borderLeftWidth + node.parentNode.style.borderRightWidth + node.parentNode.style.paddingLeft + node.parentNode.style.paddingRight);
		node = node.parentNode;
		if (!isIE)
			return nRes;
	}
	return nRes;
}

function getOffsetTop(node)
{
	var nRes = 0;
	while ((node) && (node.parentNode) && (node.parentNode.offsetTop))
	{
		nRes += node.parentNode.offsetTop;
		if (node.parentNode.style.borderTopWidth)
			nRes += (node.parentNode.style.borderTopWidth + node.parentNode.style.borderBottomWidth + node.parentNode.style.paddingTop + node.parentNode.style.paddingBottom);
		node = node.parentNode;
		if (!isIE)
			return nRes;
	}
	return nRes;
}

function showSubMenu()
{
	var node = isUL(this.firstChild);
	if (node)
	{
		hideSubMenuTimeOut();
		node.style.visibility = "visible";
		node.style.display = "block";
	}
}

function hideSubMenu()
{
	globalNode = this;
	timeout = setTimeout('hideSubMenuTimeOut()', delay);
}

function hideSubMenuTimeOut()
{
	if (globalNode)
	{
		node = isUL(globalNode.firstChild);
		if (node)
		{
			node.style.visibility = "hidden";
			node.style.display = "none";
		}
		globalNode = null;
		timeout = null;
	}
}

window.onload = insertScript;